-module(schemelib).
-export([box/1,unbox/1,setbox/2,boxprocess/1]).

box(Value) ->
  spawn(schemelib,boxprocess,[Value]).

setbox(Cell,New) ->
  Cell ! {setbox,New}.

unbox(Cell) ->
  R = make_ref(),
  Cell ! {R,self()},
  receive
    {R,Result} -> Result
  end.

boxprocess(Value) ->
  receive
    {setbox,New} -> boxprocess(New);
    {R,Pid}      -> Pid ! {R,Value}, boxprocess(Value)
  end.
