(define (fib n)
  (if (< n 2) 1 (+ (fib (- n 1)) (fib (- n 2)))))

(define (fact n)
  (if (< n 2) 1 (* n (fact (- n 1)))))

(define (iota n)
  (iota-2 n '()))

(define (iota-2 i lst)
  (if (> i 0)
      (iota-2 (- i 1) (cons i lst))
      lst))

(define (tally)
  (let ((sum 0))
    (lambda (x)
      (set! sum (+ sum x))
      sum)))

(define (process n dest)
  (lambda () (! dest (map (?) (iota n)))))

(define (main)
  (let ((a (spawn (process 10 (self))))
        (b (spawn (process 10 (self))))
        (t1 (tally))
        (t2 (tally)))
    (! a fib)
    (! b fact)
    (map t1 (?))
    (map t2 (?))
    (list (t1 0) (t2 0))))
